/*******************************************************************
    (An example of how to use a custom reply keyboard markup.)                                                              *
    written by Vadim Sinitski

    modified by Dejan Lauber 
 *******************************************************************/
#include <ESP8266WiFi.h>

//uncomment to use wificlientsecure
//#include <WiFiClientSecure.h>
//uncomment to use httpsredirect
#include <HTTPSRedirect.h>

#include <UniversalTelegramBot.h>


//uncomment to use wificlientsecure
//WiFiClientSecure client;
//uncomment to use httpsredirect
HTTPSRedirect client(433);


//fill memory for testing purposes
struct fillObj {
  char data[100] = "234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890";
};
fillObj filler[100];

// Initialize Wifi connection to the router
char ssid[] = "xxxx";     // your network SSID (name)
char password[] = "xxxx"; // your network key

// Initialize Telegram BOT
#define BOTtoken "xxxx"  // your Bot Token (Get from Botfather)

UniversalTelegramBot bot(BOTtoken, client);

int Bot_mtbs = 1000; //mean time between scan messages
long Bot_lasttime;   //last time messages' scan has been done

String test_photo_url = "https://www.arduino.cc/en/uploads/Trademark/ArduinoCommunityLogo.png";

void handleNewMessages(int numNewMessages) {
  Serial.println("handleNewMessages");
  Serial.println(String(numNewMessages));

  for (int i = 0; i < numNewMessages; i++) {
    String chat_id = String(bot.messages[i].chat_id);
    String text = bot.messages[i].text;

    String from_name = bot.messages[i].from_name;
    if (from_name == "") from_name = "Guest";

    if (text == "/get_test_photo") {
      bot.sendPhoto(chat_id, test_photo_url, "free heap: " + String(ESP.getFreeHeap()));
    }
    if (text == "/status") {
      String msg = "/status\n";
      for (byte j = 0; j < 10; j++) {
        msg += "don't you look lovely today!\n";
      }
      Serial.println("free heap: " + String(ESP.getFreeHeap()) + " B\n");
      Serial.println("msg length: " + String(msg.length()));
      Serial.println("sendMessage start: " + String(millis()) + " ms");
      bot.sendMessage(chat_id, msg, "");
      Serial.println("sendMessage stop: " + String(millis()) + " ms");
    }

    if (text == "/start") {
      String welcome = "Welcome to Universal Arduino Telegram Bot library, " + from_name + ".\n";
      welcome += "This is Send Image From URL example.\n\n";
      welcome += "/get_test_photo : getting test photo\n";
      welcome += "/status : get status\n";

      bot.sendMessage(chat_id, welcome, "");
    }
  }
}

void setup() {
  Serial.begin(115200);

  // Set WiFi to station mode and disconnect from an AP if it was Previously connected
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);

  // attempt to connect to Wifi network:
  Serial.print("Connecting Wifi: ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(500);
  }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
}

void loop() {
  if (millis() > Bot_lasttime + Bot_mtbs)  {
    int numNewMessages = bot.getUpdates(bot.last_message_received + 1);

    while (numNewMessages) {
      Serial.println("got response");
      handleNewMessages(numNewMessages);
      numNewMessages = bot.getUpdates(bot.last_message_received + 1);
    }

    Bot_lasttime = millis();
  }
}
